﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UGCellUpdates
{
    public partial class Form1 : Form
    {
        private bool updatedOnce = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ultraGrid1.DisplayLayout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
            ultraGrid1.DisplayLayout.Bands[0].Columns[0].ValueList = this.ultraCombo1;
            ultraGrid1.DisplayLayout.Bands[0].Columns[0].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            ultraGrid1.DisplayLayout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].ValueList = this.ultraCombo2;
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateGridDataSource();
            CreateUltraCombo1DS();
            CreateUltraCombo2DS();
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (this.updatedOnce)
            {
                IValueList vl1 = this.ultraCombo1;
                IValueList vl2 = this.ultraCombo2;

                if (e.Cell.Column == this.ultraGrid1.DisplayLayout.Bands[0].Columns["ItemID"])
                {
                    UltraGridRow row = e.Cell.Row;
                    this.updatedOnce = false;
                    row.Cells["ItemDescription"].Value = vl2.GetText(vl1.SelectedItemIndex); 
                }
                else if (e.Cell.Column == this.ultraGrid1.DisplayLayout.Bands[0].Columns["ItemDescription"])
                {
                    UltraGridRow row = e.Cell.Row;
                    this.updatedOnce = false;
                    row.Cells["ItemID"].Value = vl1.GetText(vl2.SelectedItemIndex);
                }
            }
        }
        private void CreateUltraCombo2DS()
        {
            var dataTable = new DataTable("ItemDescription");
            dataTable.Columns.Add("ItemDescription");
            this.ultraCombo2.ValueMember = "ItemDescription";
            this.ultraCombo2.DisplayMember = "ItemDescription";
            DataRow row = dataTable.NewRow();
            row["ItemDescription"] = "Item Description 1";
            dataTable.Rows.Add(row);
            row = dataTable.NewRow();
            row["ItemDescription"] = "Item Description 2";
            dataTable.Rows.Add(row);
            this.ultraCombo2.DataSource = dataTable;
        }

        private void CreateUltraCombo1DS()
        {
            var dataTable = new DataTable("ItemID");
            dataTable.Columns.Add("ItemID");
            this.ultraCombo1.ValueMember = "ItemID";
            this.ultraCombo1.DisplayMember = "ItemID";
            DataRow row = dataTable.NewRow();
            row["ItemID"] = "1";
            dataTable.Rows.Add(row);
            row = dataTable.NewRow();
            row["ItemID"] = "2";
            dataTable.Rows.Add(row);
            this.ultraCombo1.DataSource = dataTable;
        }

        private void CreateGridDataSource()
        {
            DataSet dataSet = new DataSet();
            var dataTable = new DataTable("Table1");
            dataSet.Tables.Add(dataTable);
            dataTable.Columns.Add("ItemID");
            dataTable.Columns.Add("ItemDescription");
            dataTable.Columns.Add("OtherCell");
            DataRow row = dataTable.NewRow();
            row["ItemID"] = "1";
            row["ItemDescription"] = "Item Description 1";
            row["OtherCell"] = "Other cell 1";
            dataTable.Rows.Add(row);
            row = dataTable.NewRow();
            row["ItemID"] = "2";
            row["ItemDescription"] = "Item Description 2";
            row["OtherCell"] = "Other cell 2";
            dataTable.Rows.Add(row);

            dataTable.Rows.Add(dataTable.NewRow());

            this.ultraGrid1.DataSource = dataSet;
        }

        private void ultraCombo1_ValueChanged(object sender, EventArgs e)
        {
            this.updatedOnce = true;
        }

        private void ultraCombo2_ValueChanged(object sender, EventArgs e)
        {
            this.updatedOnce = true;
        }
    }
}
